clc
clear all

global  kstart dstart fks fds nu gammaq omegas ss lastObs firstObs sigma alpha beta deltak deltad kappak kappad phi nBar T IfSave kstar dstar

deltak=0.0188;
deltad=0.0129;
alpha=0.646;
T=160;
% r=0.000291584;
r=.05/4;
rStar=r;
beta=1/(1+rStar);
nBar=.945;
sigma=0.5;
nu=0.12;
gammaq=0.14;
cFunc=[];
kappak=8;
kappad=8;
phi=0.82;
rhos=0.98;
rhof=0.8;

%  Static solution

%      y k d c pc

pk=rStar+deltak;
k=nBar*((1-alpha)/pk)^(1/alpha);
y=nBar^alpha*k^(1-alpha);
x=[y;k;k;.5;1];
discs=StatModel(x);
MaxFunEvals=50000;
MaxIter=500;
options=optimset('Display','iter','MaxFunEvals',MaxFunEvals,'MaxIter',MaxIter,'Algorithm','levenberg-marquardt','TolFun',.00000000001,'TolX',.000000001);
xNew=fsolve(@StatModel,x,options);
% xNew=y k d c pc
resNew=StatModel(xNew);
kstar=xNew(2);
dstar=xNew(3);
cons=xNew(4);

%for kstart=84.8:4:88.8
% for dstart=39.56:4:43.56;
%   for sval=0:.04:.04
%     for fval=0:.004:.004
%        for omega=0:0.513:0.513
% for kstart=84.8:2:88.8
%   for dstart=39.56:2:43.56;
%       for sval=0:2:4
%           for fval=0:.002:.004
for kstart=kstar
    for dstart=dstar*1.114
        for sval=.067
            for fval=0.005
                for omega=0.513
                    %  Dynamic solution
                    
                    pd=rStar+deltad;
                    % Core: pd    c    k     d   r
                    xStarts=[pd;cons;kstar;dstar;rStar];
                    Nvar=numel(xStarts);
                    firstObs(1:5)=2;  %  pd, c,  k, d, r
                    lastObs(1:2)=T; %  pd, c
                    lastObs(3:5)=T-1; %   k, d, r
                    loc=1;
                    for var=1:Nvar
                        for t=firstObs(var):lastObs(var)
                            x(loc)=xStarts(var);
                            loc=loc+1;
                        end
                    end
                    
                    %  Exogenous variables
                    
                    ss=zeros(T,1);
                    ss(2)=sval;
                    for t=2:T-1
                        ss(t+1)=ss(t)*rhos;
                    end
                    omegas(1:T,1)=omega;
                    
                    fk=fval;
                    for t=2:T
                        fks(t,1)=fk;
                        fk=fk*rhof;
                    end
                    fds=fks;
                    
                    % Checks
                    
                    IfSave=true;
                    discs=PA2SCCModel(x);
                    load PA2SCCModel AllVars
                    AllVars1=AllVars;
                    
                    %  Solve
                    
                    MaxFunEvals=30000;
                    MaxIter=200;
                    IfSave=false;
                    options=optimset('Display','iter','MaxFunEvals',MaxFunEvals,'MaxIter',MaxIter,'Algorithm','levenberg-marquardt','TolFun',.00000000000001,'TolX',.000000000001);
                    xN=fsolve(@PA2SCCModel,x,options);
                    
                    %  Extract variables
                    
                    IfSave=true;
                    Check=PA2SCCModel(xN);
                    IfSave=false;
                    load PA2SCCModel AllVars
                    cFunc=[cFunc;kstart,dstart,sval,fval,omega,AllVars(2,2),AllVars(2,5),std(Check)];
                end % omega
            end % fval
        end % sval
    end % kstart
end%  dstart

